# Tamito KAJIYAMA <21 September 2001>
# NOTE: This file contains Japanese characters (EUC-JP).

from eb import *

import os

PATH = os.path.join(os.getcwd(), "ej")
DISC = EB_DISC_EPWING
CHARCODE = EB_CHARCODE_JISX0208
SUBBOOK = 0
TITLE = "¡±Ѽŵ"
DIRECTORY = "ej"

def check_book(is_bound):
    if is_bound:
        assert(eb_path(book) == PATH)
        assert(eb_disc_type(book) == DISC)
        assert(eb_character_code(book) == CHARCODE)
        assert(eb_subbook_list(book) == (SUBBOOK,))
    else:
        try: error = eb_path(book)
        except EBError, (error, message): pass
        assert(error == EB_ERR_UNBOUND_BOOK)
        try: error = eb_disc_type(book)
        except EBError, (error, message): pass
        assert(error == EB_ERR_UNBOUND_BOOK)
        try: error = eb_character_code(book)
        except EBError, (error, message): pass
        assert(error == EB_ERR_UNBOUND_BOOK)
        try: error = eb_subbook_list(book)
        except EBError, (error, message): pass
        assert(error == EB_ERR_UNBOUND_BOOK)

def check_subbook(is_bound):
    if is_bound:
        # set
        assert(eb_set_subbook(book, SUBBOOK) == None)
        assert(eb_subbook(book) == SUBBOOK)
        assert(TITLE == eb_subbook_title(book))
        assert(TITLE == eb_subbook_title2(book, SUBBOOK))
        assert(DIRECTORY == eb_subbook_directory(book))
        assert(DIRECTORY == eb_subbook_directory2(book, SUBBOOK))
        # unset
        assert(eb_unset_subbook(book) == None)
        try: error = eb_subbook(book)
        except EBError, (error, message): pass
        assert(error == EB_ERR_NO_CUR_SUB)
        try: error = eb_subbook_title(book)
        except EBError, (error, message): pass
        assert(error == EB_ERR_NO_CUR_SUB)
        assert(TITLE == eb_subbook_title2(book, SUBBOOK))
        try: error = eb_subbook_directory(book)
        except EBError, (error, message): pass
        assert(error == EB_ERR_NO_CUR_SUB)
        assert(DIRECTORY == eb_subbook_directory2(book, SUBBOOK))
    else:
        # set
        try: error = eb_set_subbook(book, SUBBOOK)
        except EBError, (error, message): pass
        assert(error == EB_ERR_UNBOUND_BOOK)
        try: error = eb_subbook(book)
        except EBError, (error, message): pass
        assert(error == EB_ERR_NO_CUR_SUB)
        try: error = eb_subbook_title(book)
        except EBError, (error, message): pass
        assert(error == EB_ERR_NO_CUR_SUB)
        try: error = eb_subbook_title2(book, SUBBOOK)
        except EBError, (error, message): pass
        assert(error == EB_ERR_UNBOUND_BOOK)
        try: error = eb_subbook_directory(book)
        except EBError, (error, message): pass
        assert(error == EB_ERR_NO_CUR_SUB)
        try: error = eb_subbook_directory2(book, SUBBOOK)
        except EBError, (error, message): pass
        assert(error == EB_ERR_UNBOUND_BOOK)
        # unset
        assert(eb_unset_subbook(book) == None)
        try: error = eb_subbook(book)
        except EBError, (error, message): pass
        assert(error == EB_ERR_NO_CUR_SUB)
        try: error = eb_subbook_title(book)
        except EBError, (error, message): pass
        assert(error == EB_ERR_NO_CUR_SUB)
        try: error = eb_subbook_title2(book, SUBBOOK)
        except EBError, (error, message): pass
        assert(error == EB_ERR_UNBOUND_BOOK)
        try: error = eb_subbook_directory(book)
        except EBError, (error, message): pass
        assert(error == EB_ERR_NO_CUR_SUB)
        try: error = eb_subbook_directory2(book, SUBBOOK)
        except EBError, (error, message): pass
        assert(error == EB_ERR_UNBOUND_BOOK)

def test_bound():
    assert(eb_is_bound(book) == 1)
    check_book(1)
    check_subbook(1)

def test_unbound():
    assert(eb_is_bound(book) == 0)
    check_book(0)
    check_subbook(0)

eb_initialize_library()

book = EB_Book()
test_unbound()

assert(eb_bind(book, PATH) == None)
test_bound()

assert(eb_suspend(book) == None)
test_bound()

assert(eb_bind(book, PATH) == None)
test_bound()

eb_finalize_library()
