# Tamito KAJIYAMA <21 September 2001>

from eb import *

eb_initialize_library()

book = EB_Book()
assert(eb_bind(book, "ej") == None)
assert(eb_set_subbook(book, 0) == None)

assert(eb_have_narrow_font(book) == 1)
assert(eb_have_wide_font(book) == 1)
assert(eb_font_list(book) == (EB_FONT_16,))
assert(eb_have_font(book, EB_FONT_16) == 1)
assert(eb_have_font(book, EB_FONT_24) == 0)
assert(eb_have_font(book, EB_FONT_30) == 0)
assert(eb_have_font(book, EB_FONT_48) == 0)

eb_set_font(book, EB_FONT_16)
assert(eb_font(book) == EB_FONT_16)

# narrow font

height = 16
assert(height == eb_font_height(book))
assert(height == eb_font_height2(EB_FONT_16))

width = 8
assert(width == eb_narrow_font_width(book))
assert(width == eb_narrow_font_width2(EB_FONT_16))

char = eb_narrow_font_start(book)
assert(eb_narrow_font_end(book) == char)

bitmap = eb_narrow_font_character_bitmap(book, char)
print repr(bitmap)

xbm = eb_bitmap_to_xbm(bitmap, width, height)
print xbm
xpm = eb_bitmap_to_xpm(bitmap, width, height)
print xpm
gif = eb_bitmap_to_gif(bitmap, width, height)
print repr(gif)

# wide font

width = 16
assert(width == eb_wide_font_width(book))
assert(width == eb_wide_font_width2(EB_FONT_16))

char = eb_wide_font_start(book)
assert(eb_wide_font_end(book) == char)

bitmap = eb_wide_font_character_bitmap(book, char)
print repr(bitmap)

xbm = eb_bitmap_to_xbm(bitmap, width, height)
print xbm
xpm = eb_bitmap_to_xpm(bitmap, width, height)
print xpm
gif = eb_bitmap_to_gif(bitmap, width, height)
print repr(gif)

eb_finalize_library()
