# Tamito KAJIYAMA <4 February 2001>
# NOTE: This file contains Japanese characters (EUC-JP).

from eb import *

def hook_font(book, appendix, container, code, argv):
    if code == EB_HOOK_NARROW_FONT:
        try:
            text = eb_narrow_alt_character_text(appendix, argv[0])
        except EBError, (error, message):
            text = "<gaiji=h%04x>" % argv[0]
            assert(error == EB_ERR_NO_CUR_APPSUB)
        return eb_write_text_string(book, text)
    elif code == EB_HOOK_WIDE_FONT:
        try:
            text = eb_wide_alt_character_text(appendix, argv[0])
        except EBError, (error, message):
            text = "<gaiji=z%04x>" % argv[0]
            assert(error == EB_ERR_NO_CUR_APPSUB)
        return eb_write_text_string(book, text)
    return EB_SUCCESS

def hook_newline(book, appendix, container, code, argv):
    return eb_write_text_string(book, "<br>\n")

def hook_tags(book, appendix, container, code, argv):
    if code == EB_HOOK_BEGIN_KEYWORD:
        return eb_write_text_string(book, "<keyword>")
    elif code == EB_HOOK_END_KEYWORD:
        return eb_write_text_string(book, "</keyword>")
    elif code == EB_HOOK_BEGIN_REFERENCE:
        return eb_write_text_string(book, "<reference>")
    elif code == EB_HOOK_END_REFERENCE:
        return eb_write_text_string(book, "</reference=%04x:%04x>" % (argv[1], argv[2]))
    return EB_SUCCESS

text_hooks = (
    (EB_HOOK_NEWLINE,         hook_newline),
    (EB_HOOK_NARROW_FONT,     hook_font),
    (EB_HOOK_WIDE_FONT,	      hook_font),
    (EB_HOOK_BEGIN_KEYWORD,   hook_tags),
    (EB_HOOK_END_KEYWORD,     hook_tags),
    (EB_HOOK_BEGIN_REFERENCE, hook_tags),
    (EB_HOOK_END_REFERENCE,   hook_tags))

def search(func, word):
    eb_search_exactword(book, word)
    buffer = []
    while 1:
        hitlist = eb_hit_list(book)
        if not hitlist:
            break
        buffer.extend(list(hitlist))
    for heading, text in buffer:
        eb_seek_text(book, heading)
        print "Heading:", eb_read_heading(book, appendix, hookset, None)
        eb_seek_text(book, text)
        print "Text:", eb_read_text(book, appendix, hookset, None)

eb_initialize_library()

book, appendix, hookset = EB_Book(), EB_Appendix(), EB_Hookset()
assert(eb_set_hooks(hookset, text_hooks) == None)

assert(eb_bind(book, "ej") == None)
assert(eb_set_subbook(book, 0) == None)

search(0, "襤")
search(0, "襤餷")
search(0, "Ѥ")
search(0, "smiley")

eb_finalize_library()
