# Tamito KAJIYAMA <15 September 2001>

from eb import *

def hook_tags(book, appendix, container, code, argv):
    if code == EB_HOOK_BEGIN_REFERENCE:
        return eb_write_text_string(book, "<reference>")
    elif code == EB_HOOK_END_REFERENCE:
        href = (argv[1], argv[2])
        container.append(href)
        return eb_write_text_string(book, "</reference=%04x:%04x>" % href)
    return EB_SUCCESS

eb_initialize_library()

text_hooks = (
    (EB_HOOK_BEGIN_REFERENCE, hook_tags),
    (EB_HOOK_END_REFERENCE,   hook_tags),
    )

book, appendix, hookset = EB_Book(), EB_Appendix(), EB_Hookset()
assert(eb_set_hooks(hookset, text_hooks) == None)

assert(eb_bind(book, "ej") == None)
assert(eb_set_subbook(book, 0) == None)

links = []
def show_text(position):
    assert(eb_seek_text(book, position) == None)
    print eb_read_text(book, appendix, hookset, links)

assert(eb_have_menu(book) == 1)
show_text(eb_menu(book))

for position in links:
    print "-" * 60
    print "Position: %04x:%04x" % position
    show_text(position)

eb_finalize_library()
