# Tamito KAJIYAMA <14 September 2001>

from freepwing import *
import string

text      = Text()
heading   = Heading()
word2     = Word2()
menu      = Menu()
copyright = Copyright()
initialize_fpwparser(text, heading, word2, menu, copyright)

known_tags = {}
def make_tag(s):
    tag = make_ref(s)
    serial = known_tags.get(tag, 0)
    known_tags[tag] = serial + 1
    if serial == 0:
        return tag
    return "%sN%d" % (tag, serial)

def make_ref(s):
    return "T%s" % string.join(map(lambda x: "%02X" % ord(x), s), "")

gaiji = { "iuml": 0, "smiley": 1 }

def convert(filename):
    file = open(filename)
    while 1:
        # read next line
        line = file.readline()
        if not line:
            break
        entry, body = string.split(string.strip(line), None, 1)
        # create new entries
        heading.new_entry()
        text.new_entry()
        # add text to the heading entry
        heading.add_text(entry)
        # add text to the text entry
        text.add_entry_tag(make_tag(entry))
        text.add_keyword_start()
        text.add_text(entry)
        text.add_keyword_end()
        if body[:2] == "":
            text.add_text(" ")
            text.add_reference_start()
            text.add_text(body)
            text.add_reference_end(make_ref(body[2:]))
        else:
            text.add_text(" ")
            end = 0
            while 1:
                pos = string.find(body, '&', end)
                if pos < 0:
                    break
                text.add_text(body[end:pos])
                name = body[pos+1:string.find(body, ';', pos)]
                if gaiji[name]:
                    text.add_full_user_character(name)
                else:
                    text.add_half_user_character(name)
                end = pos + len(name) + 2
            text.add_text(body[end:])
        text.add_newline()
        # add index entry
        word2.add_entry(entry, heading.entry_position(), text.entry_position())

def insert_file(obj, filename):
    for line in open(filename).readlines():
        if line[:-1]:
            obj.add_text(line[:-1])
        obj.add_newline()

convert("dict-ej.txt")
text.new_context()
convert("dict-je.txt")

menu.add_reference_start()
menu.add_text("ŻҼˤĤ")
menu.add_reference_end("README")
menu.add_newline()
menu.add_reference_start()
menu.add_text("饤󥹾")
menu.add_reference_end("LICENSE")
menu.add_newline()
menu.new_context()
menu.add_tag("README")
insert_file(menu, "README")

copyright.add_tag("LICENSE")
insert_file(copyright, "LICENSE")

finalize_fpwparser(text, heading, word2, menu, copyright)
